'Programm zur Kalibrierung des internen RC-Oszillators einse ATtiny2313
'Hardware: Piezzo, 2 Tasten, LCD
'Fuses auf internen Takt mit 4 MHz
'--------------------------------------------------------------
$regfile = "attiny2313.dat"                                 'AT90S2313
$crystal = 4000000                                          '4MHz-Quarz


'******** Deklarationen ********
Dim Kalibrierungsbyte As Byte
Piezzo Alias Portd.0                                        'PIN zur Tonausgabe

'******** Initialisierung ********
Config Int0 = Falling
Enable Int0
Config Int1 = Falling
Enable Int1
Config Timer1 = Timer , Prescale = 1

Enable Interrupts
On Int0 Taste_0_interrupt                                   'Interrupt fr Taste definieren
On Int1 Taste_1_interrupt
On Timer1 Ton_irq

Ddrb = &B11111111                                           'PortB als Ausgang konfigurieren
Ddrd = &B1110001                                            'Eingnge fr Tasten, Ausgnge fr 3 LEDs, 1 LautsprecherPortd.2 = 1                                                 'pull up fr die Taste
Portd.2 = 1                                                 'pull up fr Tasten an
Portd.3 = 1                                                 'pull up fr Tasten an


Config Lcdmode = Port
Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7 , E = Portb.3 , Rs = Portb.2


'******** Hauptprogramm ********
Cls
Cursor Off
Lcd "Abgleich OscCal"
Enable Timer1                                               ' Ton an

Do
   Kalibrierungsbyte = Osccal
   Home Lower
   Lcd "OSCCAL: " ; Kalibrierungsbyte
Loop

'******** Unterprogramme ********
Taste_0_interrupt:
   Disable Int0
   Kalibrierungsbyte = Kalibrierungsbyte + 1
   If Kalibrierungsbyte > 127 Then Kalibrierungsbyte = 127
   Osccal = Kalibrierungsbyte
   Enable Int0
Return

Taste_1_interrupt:
   Disable Int1
   Kalibrierungsbyte = Kalibrierungsbyte - 1
   If Kalibrierungsbyte < 1 Then Kalibrierungsbyte = 1
   Osccal = Kalibrierungsbyte
   Enable Int1
Return
'******** Interruptprogramm fr Timer1
Ton_irq:
   Timer1 = 63263                                           'Ton a mit 880 Hz                                                '
   Toggle Piezzo
Return

End
